require_relative 'deck.rb'
require_relative 'UI.rb'
require_relative 'game_logic.rb'
class Game

  class << self
    attr_reader :deck, :correct
    def initialize(args={})
      @current_card = nil
      @file = args[:file] || ARGV[0]
      @deck = Deck.initialize(@file)
      @user_exit = false
      @counter = 0
      @correct = false
    end

    def play
      View.game_intro
      while !@user_exit && @counter < deck.length
        sleep(0.5)
        # repeat = true
        @correct = false
        @current_card = deck[@counter]
        View.show_question(@current_card)
        check_answer
        @counter += 1
      end
    end
    def check_answer
      while !@correct
        sleep(0.5)
        View.render("Guess:")
        answer = GameLogic.user_input
        if answer == @current_card.answer
          @correct = true
          View.correct_answer
        elsif answer.downcase == "exit"
          @user_exit = true
          break
        else
          View.wrong_answer
          try_again = GameLogic.user_input
          if try_again == 'n'
            View.show_answer(@current_card)
            break
          end
        end
      end
    end
  end
end

